<template>
  <div>
    <li v-if="resource.type?.options?.gitLab?.repoUrl">
      <b>{{ `${$t("resourceType.gitlab.domainLabel")} ` }}</b>
      {{ resource.type.options.gitLab.repoUrl }}
    </li>
    <li v-if="resource.type?.options?.gitLab?.projectId">
      <b>{{ `${$t("resourceType.gitlab.projectLabel")} ` }}</b>
      {{ gitlabInformation.project ? gitlabInformation.project.name : "" }}
    </li>
    <li v-if="resource.type?.options?.gitLab?.branch">
      <b>{{ `${$t("resourceType.gitlab.referenceLabel")} ` }}</b>
      {{ resource.type.options.gitLab.branch }}
    </li>
  </div>
</template>

<script lang="ts" setup>
import useResourceStore from "../../../store";
import type { GitlabInformation } from "@/modules/resource/types";
import type {
  GitlabProjectDto,
  ResourceDto,
} from "@coscine/api-client/dist/types/Coscine.Api";

const resource = defineModel<ResourceDto>({ required: true });

const resourceStore = useResourceStore();

const gitlabInformation = ref({
  domain: "",
  accessToken: "",
  project: null,
  branch: null,
} as GitlabInformation);
const gitlabProjects = ref([] as GitlabProjectDto[] | null | undefined);

const getGitlabProjectName = async () => {
  if (
    resource.value?.type?.options?.gitLab?.repoUrl &&
    resource.value?.type?.options?.gitLab?.accessToken
  ) {
    gitlabProjects.value = await resourceStore.getGitlabAllProjects(
      resource.value?.type?.options?.gitLab?.repoUrl,
      resource.value?.type?.options?.gitLab?.accessToken,
    );
    if (gitlabProjects.value) {
      gitlabInformation.value.project =
        gitlabProjects.value.find(
          (p) => p.id === resource.value?.type?.options?.gitLab?.projectId,
        ) ?? null;
    }
  }
};

getGitlabProjectName();
</script>
